<?

 /*************************************************************************************
 * Filename: forum.php
 *
 * This file is part of the Forum JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Forum JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/forum/
 *************************************************************************************/


 require_once($_path["include"]."history.php");
 require_once($_path["include"]."data.php");
 require_once($_path["include"]."cms.php");
 require_once($_path["format"]."template.php");

 class Plugin_forum extends Base_Plugin
 {
  function cache(&$cacheTime, &$cacheKey)
  {
   return false;
  }

  function output()
  {
   global $_path, $_config;

   $output=false;

   if(!$this->config)
    return false;

   //determine what to display (categories, thread list, thread)
   $post=false;
   $thread=false;
   $category=false;
   $arg=request("p"); //get parameters 
   $pagebrowser_args=Array();

   if(isset($arg[3])&&preg_match("/^\d+$/", $arg[3])) //thread
   {
    $post=$arg[3];

    if(isset($arg[5])&&($arg[5]=="reply"||$arg[5]=="replytop"||$arg[5]=="quote"||$arg[5]=="edit"||$arg[5]=="move"||$arg[5]=="delete"))
     $show=Array("tree", "cms");
    else
     $show=Array("tree", "forum_threads");

    //get forum thread category and pagebrowser_args
    $d=Data::cache("forum_threads", "tree", "up");
    $d->setShowFields("catnr", "subject"); 
    $d->clearValues();

    $d->setValue("threadnr", $post);

    if(!isset($d->reference["catnr"]["data"]))
     $d->initReferenceData("catnr");

    $d->reference["catnr"]["data"]->setShowFields("name");

    if(!$d->get(1))
    {
     $this->e->add($d->e);
     return false;
    }

    if(!$d->next()) // thread doesn't exists, (category is false as well so entry page will be shown)
     $post=false;
    else
    {
     //get (top) thread values
     $category=$d->v["catnr"]["nr"];
     $thread=$d->v["nr"];

     $d->reset(); //reset in case post is the top thread

     //get post values
     if($d->search("nr", $post)) 
     {
      $pagebrowser_args[]=$d->v["catnr"]["nr"];
      $pagebrowser_args[]=str_replace(" ", "_", $d->v["catnr"]["name"]);
      $pagebrowser_args[]=$d->v["nr"];
      $pagebrowser_args[]=str_replace(" ", "_", $d->v["subject"]);
     }
    }
   }
   else if(isset($arg[1])&&preg_match("/^\d+$/", $arg[1])) //category
   {
    $category=$arg[1];

    if(isset($arg[3])&&($arg[3]=="add"||$arg[3]=="edit"||$arg[3]=="move"||$arg[3]=="delete"||$arg[3]=="post"))
     $show=Array("tree", "cms");
    else
     $show=Array("tree", "forum_threads", "forum_categories");

    //get current forum category
    $d=Data::cache("categories", "view", "item");
    $d->setShowFields("name");
    $d->clearValues();

    $d->setValue("nr", $category);

    if(!$d->get()||!$d->next())
    {
     $this->e->add($d->e);
     return false;
    }

    $pagebrowser_args[]=$d->v["nr"];
    $pagebrowser_args[]=str_replace(" ", "_", $d->v["name"]);
   }

   if(!$category) //no category set, either because it's the entry page or no valid thread was requested
   {
    $show=Array("tree", "forum_categories");

    //get top forum category
    $d=Data::cache("categories", "view", "all");
    $d->setShowFields("nr");
    $d->clearValues();

    $d->setValue("module", Array("forum_categories"));
    $d->setValue("show_total", 1);

    if(!$d->get()||!$d->next())
    {
     $this->e->add($d->e);
     return false;
    }

    $category=$d->v["nr"];
   }


   //display all modules
   foreach($show as $module)
   {
    if($module=="cms") //content management
    {
     $cms=new CMS(Array(
      "showTitles" => false, 
      "showText" => false, 
      "showSubmitAdditional" => false,
      "reloadTimeout" => 0
     ));
     
     if(isset($arg[3])&&($arg[3]=="post"))
     {
      $d=Data::cache("forum_threads", "add", "item");

      $d->setValue("catnr", $category);
      $d->setValue("threadnr", 0);

      $d->field["catnr"]["properties"]=";hidden";
      $d->field["threadnr"]["properties"]=";hidden";

     }
     else if(isset($arg[5])&&($arg[5]=="reply"||$arg[5]=="replytop"||$arg[5]=="quote"||$arg[5]=="edit"||$arg[5]=="move"||$arg[5]=="delete"))
     {
      if($arg[5]=="replytop"||$arg[5]=="reply"||$arg[5]=="quote")
      {
       $d=Data::cache("forum_threads", "add", "item");
       $d->setValue("catnr", $category);

       if($arg[5]=="replytop") //reply to top thread
        $d->setValue("threadnr", $thread);
       else //reply / quote sub post
        $d->setValue("threadnr", $post);

       if(!request("s")) //only initial values for reply/quote
       {
        $d2=Data::cache("forum_threads", "view", "item");

        if($arg[5]=="replytop"||$arg[5]=="reply")
        {
         if($arg[5]=="replytop") //reply to top thread
          $d2->setValue("nr", $thread);
         else //reply / quote sub post
          $d2->setValue("nr", $post);

         //get subject
         $d2->setShowFields("subject");

         if($d2->get())
          $d->setValue("subject", $d2->getValue("subject"));
        }
        else if($arg[5]=="quote")
        {
         $d2->setValue("nr", $post);

         //get subject and quoted message
         $d2->setShowFields("subject", "message");

         if($d2->get())
         {
          $d->setValue("subject", $d2->getValue("subject"));
          $d->setValue("message", "<br/>Quote<br/><div class=\"quote\">".$d2->getValue("message")."</div><br/>");
         }
        }

        unset($d2);
       }
      }
      else
      {
       $d=Data::cache("forum_threads", $arg[5], "item");

       $d->setValue("nr", $post);
       $d->setDefaultValue("catnr");
       $d->unsetValue("threadnr");
      }

      $d->field["catnr"]["properties"]=";hidden";
      $d->field["threadnr"]["properties"]=";hidden";

     }
     else if(isset($arg[3])&&($arg[3]=="add"||$arg[3]=="edit"||$arg[3]=="move"||$arg[3]=="delete"))
     {
      $d=Data::cache("forum_categories", $arg[3], "item");

      if($arg[3]=="add")
       $d->setValue("catnr", $category);
      else
      {
       $d->setValue("nr", $category);
       $d->setDefaultValue("catnr");
      }

      //force module(lock) values
      $d->setValue("module", Array("forum_categories", "forum_threads"));
      $d->setValue("moduleLock", true);

      //hide category and module(lock) fields
      if($arg[3]!="delete")
      {
       $d->field["catnr"]["properties"]=";hidden";
       $d->field["module"]["properties"]=";hidden";
       $d->field["moduleLock"]["properties"]=";hidden";
      }
     }

     $cms->setData($d);

     //make history aware current page is a cms page
     $hs=new History();
     $hs->cms();

     $output.=$cms->form();
  
     continue;
    }
    else if($module=="tree") //crumbtrail 
    {
     $d=Data::cache("forum_categories", "tree", "up");
     $d->clearValues();

     $d->setValue("catnr", $category);

     if($this->config["templatetree"])
      $templateFile=$_path["project"]["templates"].$this->config["templatetree"];
     else
      $templateFile=$this->plugin->path["templates"].$this->plugin->templatetree;
    }
    else if($thread) //thread view
    {
     $d=Data::cache($module, "tree", "down");
     $d->sortOrder("updated+");
     $d->clearValues();

     $d->setValue("nr", $thread); //get current and all sub threads

     if($this->config["templateitem"])
      $templateFile=$_path["project"]["templates"].$this->config["templateitem"];
     else
      $templateFile=$this->plugin->path["templates"].$this->plugin->templateitem;
    }
    else //categories/threads view
    {
     if($module=="forum_threads") 
     {
      $d=Data::cache($module, "view", "all");
      $d->sortOrder("updated-");
      $d->clearValues();

      $d->setValue("catnr", $category);
      $d->setValue("threadnr", 0);

      if($this->config["templatelist"])
       $templateFile=$_path["project"]["templates"].$this->config["templatelist"];
      else
       $templateFile=$this->plugin->path["templates"].$this->plugin->templatelist;
     }
     else 
     { 
      $d=Data::cache($module, "view", "list");
      $d->sortOrder("ordernr");
      $d->clearValues();

      $d->setValue("catnr", $category);

      if($this->config["templatecategories"])
       $templateFile=$_path["project"]["templates"].$this->config["templatecategories"];
      else
       $templateFile=$this->plugin->path["templates"].$this->plugin->templatecategories;
     }
    }

    if($d->module=="forum_threads")
    {
     if($this->config["pagebrowser"]&&request("show_from")) //only show "next page" if page browser is active
      $d->setValue("show_from", request("show_from"));

     $d->setValue("show_total", $this->config["listitems"]);
    }

    $d->addField("sort_order", "text", "show", "control", false, false, implode(",", $d->sortOrder));

    if($_config->get("useModRewrite")) //mod rewrite
    {
     $d->addField("base_url", "text", "", "control", 0, false, $_path["HTML"]["current"]);
     $d->addField("root_url", "text", "", "control", 0, false, $_path["root"]);


     $tmp=$_path["HTML"]["current"];
     foreach($this->plugin->vars as $k => $v)
      if($k=="p"||substr($k, 0, 2)=="p[")
       $tmp.=$v."/";

     $d->addField("page_url", "text", "", "control", 0, false, $tmp);
     unset($tmp);
    }
    else
    {
     $d->addField("base_url", "text", "", "control", 0, false, "");
     $d->addField("root_url", "text", "", "control", 0, false, $_path["root"]);
     $d->addField("page_url", "text", "", "control", 0, false, htmlentities($this->plugin->url()));
    }

    $template=new Format_Template(true);

    if(!$template->read($templateFile)||!$template->analyze($d))
    {
     $this->e->add($template->e);
     return false;
    }

    if($template->markerExists("_fields")&&$this->config["showfields"]) //_fields marker in template and predefined fields set
     $dc->setShowFields(array_merge($this->config["showfields"], $dc->check("use", "show"))); //added predefined fields to show fields
    //else //use template defined fields

    //get data
    if($this->config["pagebrowser"]||$template->showCount())
     $success=$d->get($template->getLevel(), true);
    else
     $success=$d->get($template->getLevel());

    if(!$success)
    {
     $this->e->add($d->e);
     return false;
    }

    //set sort_order, page_url, base_url, root_url and item_url values
    for($c=0;$c<$d->vmax;$c++) 
    {
     $d->setDefaultValue("sort_order", $c);
     $d->setDefaultValue("page_url", $c);
     $d->setDefaultValue("base_url", $c);
     $d->setDefaultValue("root_url", $c);
    }

    //set tags
    if($d->check("use", "show", "tags"))
    {
     for($c=0;$c<$d->vmax;$c++) //loop trough all entries to calculate its relative locnr
     {
      $tags=explode(", ", $d->getValue("tags", $c));

      foreach($tags as $k => $tag)
      {
       if($_config->get("useModRewrite")) //mod rewrite
        $tags[$k]="<a href=\"".$d->getValue("page_url", $c).$tag."/\" title=\"".$tag."\">".$tag."</a>";
       else
        $tags[$k]="<a href=\"".$d->getValue("page_url", $c).htmlentities($tag)."&\" title=\"".$tag."\">".$tag."</a>";
      }

      $d->setValue("tags", implode(", ", $tags), $c);
     }
    }


    if(!$template->populate())
    {
     $this->e->add($template->e);
     return false;
    }

    $output.=$template->output();

    if($this->config["pagebrowser"]&&$d->module=="forum_threads")
    {
     if($this->config["templatepagebrowser"])
      $templateFile=$_path["project"]["templates"].$this->config["templatepagebrowser"];
     else
      $templateFile=$this->plugin->path["templates"].$this->plugin->templatepagebrowser;

     $templatepagebrowser=new Format_Template(true);

     if(!$templatepagebrowser->read($templateFile))
     {
      $this->e->add($templatepagebrowser->e);
      return false;
     }

     $page_url=$d->getValue("page_url");

     if($pagebrowser_args) //add pagebrowser_args
      $page_url.=implode("/", $pagebrowser_args)."/";

     if($templatepagebrowser->pageBrowser($d, $page_url.($_config->get("useModRewrite")?"?":"").(request("sort")?"sort=".$d->getDefaultValue("sort_order")."&amp;":""))) //add ? for args when using mod rewrite
      $output.=$templatepagebrowser->output();
    }
   }

   return $output;
  }
 }
?>
